unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Jpeg;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  idCamera: Integer;

implementation

{$R *.dfm}
function requisitaQuadroVideo(id:Integer; pPointer: PAnsiChar;formato: Integer;qualidade: Integer):Integer; cdecl; external 'itscam.dll';
function criarConexaoItscam300(ip: PAnsiChar):Integer; cdecl; external 'itscam.dll';
function leStatus(id: Integer):Integer; cdecl; external 'itscam.dll';
function fecharConexaoItscam300(id: Integer):Integer; cdecl; external 'itscam.dll';

procedure TForm1.Button1Click(Sender: TObject);
var
  status: Integer;
begin
  if idCamera = 0 then
  begin
    Label1.Caption := 'Aguarde...';
    Application.ProcessMessages;
    idCamera := criarConexaoItscam300(PAnsiChar(AnsiString(Edit1.Text)));
    status := leStatus(idCamera);
    if status = 0 then
    begin
      CheckBox1.Enabled := true;
      Edit1.Enabled := false;
      Button1.Enabled := false;
      Button2.Enabled := true;
      Label1.Caption := 'Conexao OK';
    end
    else
    begin
      CheckBox1.Enabled := false;
      Edit1.Enabled := true;
      Button1.Enabled := true;
      Button2.Enabled := false;
      Label1.Caption := 'Erro de conexao: ' + IntToStr(status);
    end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if idCamera <> 0 then
  begin
    fecharConexaoItscam300(idCamera);
    Button2.Enabled := false;
    Button1.Enabled := true;
    CheckBox1.Enabled := false;
    Edit1.Enabled := true;
    Label1.Caption := ' ';
    idCamera := 0;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var ms: TMemoryStream;
  jpg: TJPEGImage;
begin
  ms := TMemoryStream.Create;
  ms.SetSize(5*1024*1024);
  Button2.Enabled := false;
  while CheckBox1.Checked do
  begin
    {Requisita jpeg de qualidade 70}
    if requisitaQuadroVideo(idCamera,ms.Memory,1,70) > 0 then
    begin
      ms.Position := 0;
      jpg:= TJPEGImage.Create;
      jpg.LoadFromStream(ms);
      Image1.Picture.Assign(jpg);
      jpg.Free;
    end;
    Application.ProcessMessages;
  end;
  ms.Free;
  Button2.Enabled := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  idCamera := 0;
end;

end.


